/*
  ReadAnalogVoltage
  Reads an analog input on pin 0, converts it to voltage, and prints the result to the serial monitor.
  Attach the center pin of a potentiometer to pin A0, and the outside pins to +5V and ground.
 
 This example code is in the public domain.
 */
 
//#include <Adafruit_CharacterOLED.h>
#include <OLED_I2C.h>
//#include <avr/eeprom.h>
#include <EEPROM.h>

#define int_mode RISING
#define DEBUG

OLED  myOLED(SDA, SCL);
// initialize the library with the OLED hardware 
// version OLED_Vx and numbers of the interface pins. 
// OLED_V1 = older, OLED_V2 = newer. If 2 doesn't work try 1 ;)
//Adafruit_CharacterOLED lcd(OLED_V2, 6, 7, 8, 9, 10, 11, 12);

int ch=0;
char stmp[20],stmp2[20];

extern uint8_t TinyFont[];
extern uint8_t SmallFont[];

long readVcc() {
  // Read 1.1V reference against AVcc
  // set the reference to Vcc and the measurement to the internal 1.1V reference
  #if defined(__AVR_ATmega32U4__) || defined(__AVR_ATmega1280__) || defined(__AVR_ATmega2560__)
    ADMUX = _BV(REFS0) | _BV(MUX4) | _BV(MUX3) | _BV(MUX2) | _BV(MUX1);
  #elif defined (__AVR_ATtiny24__) || defined(__AVR_ATtiny44__) || defined(__AVR_ATtiny84__)
     ADMUX = _BV(MUX5) | _BV(MUX0) ;
  #else
    ADMUX = _BV(REFS0) | _BV(MUX3) | _BV(MUX2) | _BV(MUX1);
  #endif  
 
  delay(2); // Wait for Vref to settle
  ADCSRA |= _BV(ADSC); // Start conversion
  while (bit_is_set(ADCSRA,ADSC)); // measuring
 
  uint8_t low  = ADCL; // must read ADCL first - it then locks ADCH  
  uint8_t high = ADCH; // unlocks both
 
  long result = (high<<8) | low;
 
  result = 1125300L / result; // Calculate Vcc (in mV); 1125300 = 1.1*1023*1000
  return result-50; // Vcc in millivolts
}
float vref = 0, ftmp;
long vref2 = 0, tmp=0;
// the setup routine runs once when you press reset: 
byte bat0[8] = {
  0b01110,
  0b11111,
  0b10001,
  0b10001,
  0b10001,
  0b10001,
  0b11111,
  0b00000
};
byte bat1[8] = {
  0b01110,
  0b11111,
  0b10001,
  0b10001,
  0b10001,
  0b11111,
  0b11111,
  0b00000
};
byte bat2[8] = {
  0b01110,
  0b11111,
  0b10001,
  0b10001,
  0b11111,
  0b11111,
  0b11111,
  0b00000
};
byte bat3[8] = {
  0b01110,
  0b11111,
  0b10001,
  0b11111,
  0b11111,
  0b11111,
  0b11111,
  0b00000
};
byte bat4[8] = {
  0b01110,
  0b11111,
  0b11111,
  0b11111,
  0b11111,
  0b11111,
  0b11111,
  0b00000
};
void disp_ch(float vbat)
{char istmp[5];
 float fb;
 vbat=vbat/1000;
  fb = ((vbat-2.8)/1.2)*100;
  if(fb<0){
  fb=0;}
  if(fb>100){
  fb=100;}
  //int ch_n=map(ch, 0, 100, 0, 5);;
	
      /*switch ( ch_n )
      {
         case 0:
		    myOLED.print(" !\"#$%&'()*+,-./", RIGHT, 0);
		    lcd.print ( char(1));
            break;
         case 1:
		    lcd.print ( char(2));
            break;
         case 2:
		    lcd.print ( char(3));
            break;
         case 3:
		    lcd.print ( char(4));
            break;
         case 4:
		    lcd.print ( char(5));
            break;
         default:
		    lcd.print ( char(5));
      }*/
      sprintf(istmp, "%d",(int)fb);
      //sprintf(istmp, "%d",(int)vbat);
      myOLED.print(istmp, RIGHT, 0);
	  myOLED.update();
}

uint32_t sp_stat, sp_stop, sp_time;
bool sp_ch=false, sp_st=false;

void speed_mt()
{
  detachInterrupt(0);
   /*if(sp_ch==true)
    {
      sp_stop = micros();
      sp_time=sp_stop-sp_start;
      sp_ch=false;
    }
   else if(sp_ch==false)
    {
      sp_start = micros();
      sp_ch=true;
    }*/
  sp_time=micros()-sp_stat;
  sp_stat = micros();
  attachInterrupt(0, speed_mt, int_mode);
}

struct settings_p
{
  double dist, av_speed, max_speed;
  int mode;
} settings;


void setup() {
  myOLED.begin();
  myOLED.setFont(SmallFont);
  Serial.begin(9600);
  pinMode(4, OUTPUT);
  digitalWrite(4, LOW);
  delay(2000);
  Serial.println(readVcc()/ 1000.0);
  if((readVcc()/ 1000.0)<=4.5) {
      digitalWrite(4, LOW);
      EEPROM.write(0, 21);
      while(1){
       delay(1000);
       if(readVcc()/ 1000.0>4.5) {break;}
      }
    }
  digitalWrite(4, HIGH);
  pinMode(2, INPUT);    
  // initialize serial communication at 9600 bits per second:
  //attachInterrupt(0, speedm, int_mode);
  tmp=EEPROM.read(0);
  if(tmp!=21)
  {
    myOLED.clrScr();
    myOLED.print("Can't read settings", CENTER, 16);
    myOLED.print("set all to default", CENTER, 24);
    myOLED.update();
    delay(1000);
  }
  if(tmp==21)
  {
    myOLED.clrScr();
    myOLED.print("Starting parsing set", CENTER, 16);
    myOLED.print("Load:              ", CENTER, 24);
    //lcd.setCursor(7, 1);
    myOLED.print("Distance     ", CENTER, 24);
    myOLED.update();
  }
  attachInterrupt(0, speed_mt, int_mode);
  delay(500);
}

int i = 0, fl = 0;
float voltage =0;
long sensorValue, sensorValue0;


void loop() {
// read the input on analog pin 0:
//  lcd.setCursor(16, 0);
//  lcd.print(sp_ch);
//  lcd.setCursor(18, 0);
//  lcd.print(digitalRead(2));
      
      
  vref = readVcc();
    if(vref <= 2820)
    {
      myOLED.setBrightness(1);
      while(vref < 2820)
      {
        vref = readVcc();
        delay(2000);
      }
    }
    if(vref <= 3700 && fl==0)
    {
      myOLED.print("Supply voltage low! ", CENTER, 16);
      myOLED.print("Saving settings...  ", CENTER, 24);
      myOLED.update();
      EEPROM.write(0, 21);
      //EEPROM.write(1, );
      //EEPROM.write(2, val);
      detachInterrupt(0);
      fl=1;
    }
    if(vref > 3700)
    {
      myOLED.setBrightness(128);
      if(fl == 1)
      {
       myOLED.clrScr();
       fl=0; 
       attachInterrupt(0, speed_mt, int_mode);
      }
    }
  sensorValue = analogRead(A1);

  //detachInterrupt(0);
  voltage = sensorValue * (vref / 1023.0);
  if(voltage<=3.0) {
    digitalWrite(4, LOW);}
  if(voltage>3.0) {
    digitalWrite(4, HIGH);}
  Serial.print("VCC:");
  Serial.print(vref);
  Serial.print(" ");
  Serial.print(" A1:");
  Serial.print(voltage);
  Serial.print(" SP:");
  Serial.println(sp_time);
  ftmp=sp_time/1000000.0;
  sprintf(stmp,"RT: %d,%02d",(int)ftmp,(int)(ftmp*100)%100);
  /*myOLED.print(" LI:");
  lcd.print(sensorValue0/20);*/
  
  //lcd.setCursor(19, 0);
  /*myOLED.print(" CH:");
  lcd.print(((vref-2.7)/1.5)*100);
  myOLED.print("%");*/
  if(sp_time>0) {
  ftmp=(192500000.0/sp_time)*0.036;}
  else {
  ftmp=0;}
  if((micros()-sp_stat)>=77000000) {
  ftmp=0;}
  sprintf(stmp2,"SP: %d,%02dKm/h",(int)ftmp,(int)(ftmp*100)%100);
  myOLED.clrScr();
  myOLED.print(stmp, CENTER, 16);
  myOLED.print(stmp2, CENTER, 24);
  disp_ch(voltage);
  delay(300);
  i=0;
  
}
